routes/admin.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::group(['middleware' => ['auth']], function () {    

    Route::resource('sellers', 'Admin\SellerController');

    Route::resource('raffles', 'Admin\RaffleController');
    Route::get('raffle/{id}/clients', 'Admin\ClientController@index')->name('raffle.clients.index');
    Route::get('raffle/{id}/sellers', 'Admin\RaffleController@sellersIndex')->name('raffle.sellers.index');
    Route::post('raffle/{id}/upload/image', 'Admin\RaffleController@uploadImage')->name('raffle.upload.image');
    Route::get('raffle/{id}/clients/returns', 'Admin\ClientController@returns')->name('raffle.clients.returns');
});

routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('login', 'Auth\LoginController@showLoginForm')->name('login');
Route::post('login', 'Auth\LoginController@login');
Route::post('logout', 'Auth\LoginController@logout')->name('logout');

Route::group(['middleware' => ['auth']], function () {    
    Route::get('/', 'Admin\HomeController@index')->name('home');
    //Raffles generate
    Route::get('raffles/generate/unique/link/client', 'RaffleController@generateUniqueLink')->name('raffles.generate.unique.link.client');
    Route::get('raffles/{id}/generate/lottery', 'RaffleController@generateLottery')->name('raffles.generate.lottery');
});

app/Models/Raffle.php
<?php

namespace App\Models;

class Raffle extends Model
{
    protected $fillable = [
        'code', 'name', 'published_at', 'closed_at', 'description', 'total_tickets', 'ticket_price', 'created_by'
    ];

    public $rules = [
        'code' => 'required|max:5|unique:raffles,name',
        'name' => 'required',
        'published_at' => 'required',
        'closed_at' => 'required',
        'description' => 'required',
        'total_tickets' => 'required|integer',
        'ticket_price' => 'required|integer'
    ];

    protected $casts = [
        'published_at' => 'date',
        'closed_at' => 'date'
    ];

    public function clients() {
        return $this->hasMany(Client::class);
    }

    public function links() {
        return $this->hasMany(Link::class);
    }

    public function scopePublished($query) {
        return $query->where('published_at', '<=', now())->where('closed_at', '>=', now());
    }

    public function images() {
        return $this->morphMany(File::class, 'filable');
    }

    public function getUsersCountWithTicketAttribute() {
        return $this->clients()->whereNotNull('ticket')->count();
    }

    public function scopeWithCreator($query) {
        return $query->where('created_by', auth()->id())->orWhere('created_by', null);
    }

    public function sellers()
    {
        return $this->belongsToMany(Seller::class)->withPivot('id', 'paid_out');
    }

    public function getTotalCommissionAttribute() {
        $sum = 0;
        $links = $this->links()->whereNotNull('client_id')->whereNotNull('seller_id')->get();
        foreach ($links as $link) {
            $sum += $link->seller->commission;
        }        
        return $sum;
    }
}

app/Http/Controllers/Admin/RaffleController.php
<?php

namespace App\Http\Controllers\Admin;

use Illuminate\Http\Request;
use ImageResize;
class RaffleController extends Controller
{
    protected $resourceName = 'raffles';
    protected $resourceClass = \App\Models\Raffle::class;

    protected function rulesValidations($item = null){
        if ($item) {
            $item->rules['code'] = 'required|max:5|unique:raffles,code,'.$item->id;
        }
    }

    protected function afterSave($item = null, $request) {
        if ($item && is_null($item->getOriginal('created_by'))) {
            $item->created_by = auth()->id();
            $item->save();
        }
    }

    public function uploadImage(Request $request, $id) {
        if ($raffle = $this->resourceClass::find($id)) {            
            $file = new \App\Models\File;
            $request->validate($file->rules);                                    

            $image = $request->file('file');
            $name = time().'.'.$image->extension();            
            $img = ImageResize::make($image->path());
            $img->resize(400, 400, function ($constraint) {
                $constraint->aspectRatio();
            })->save(public_path('images/raffles') . '/' . $name);                        
            $raffle->images()->create([
                "id" => \Uuid::generate(4)->string,
                "name" => $name
            ]);            
            return redirect()->route('admin.raffles.edit', ['raffle' => $raffle->id]);
        }
        return abort(404);
    }

    public function sellersIndex($id) {
        if ($raffle = $this->resourceClass::find($id)) {   
            $sellers = \App\Models\Seller::withCreator()->get()->map(function ($seller) use($raffle) {
                $sellerPivot = $raffle->sellers()->find($seller->id);
                $seller->is_select = ($sellerPivot ? true : false);
                if ($seller->is_select) {
                    $seller->paid_out = $sellerPivot->pivot->paid_out;
                }                
                return $seller;
            });            
            return view('admin.raffles.sellers.index', compact('sellers', 'raffle'));
        }
        return abort(404);
    }
}

app/Http/Controllers/Api/RaffleController.php
<?php

namespace App\Http\Controllers\Api;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use DataTables;
class RaffleController extends Controller
{
    protected $resourceName = 'raffles';

    protected $resourceClass = \App\Models\Raffle::class;
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct() {}

    public function datatables() {
        $items = $this->resourceClass::withCreator()->get();                
        $datatable = DataTables::collection($items);
        $this->columns($datatable);
        $datatable->rawColumns(['actions', 'name']);
        return $datatable->make(true);
    }

    private function columns(&$datatable) {
        $datatable->editColumn('publication', function ($item) {
            return $item->published_at->format("d/m/Y") . ' al ' . $item->closed_at->format("d/m/Y");
        })->editColumn('ticket_price', function ($item) {
            return '$' . $item->ticket_price;
        })->editColumn('tickets_sold', function ($item) {
            return $item->usersCountWithTicket . '  =  $' . number_format($item->usersCountWithTicket * $item->ticket_price);
        })->editColumn('raised', function ($item) {
            return '$' . number_format((($item->usersCountWithTicket * $item->ticket_price) - $item->totalCommission));
        })->editColumn('commission', function ($item) {
            return '$' . number_format($item->totalCommission);
        })->editColumn('name', function ($item) {
            return view('common.span', ['url' => route('public.raffles.show', ['id' => $item->id]), 'text' => $item->name]);
        })->editColumn('actions', function ($item) {
            return view('common.actions', [
                "edit" => true,
                "routeEdit" => route("admin.$this->resourceName.edit", ['raffle' => $item->id]),
                "customs" => [
                    [
                        "url" => route('admin.raffle.clients.index', ['id' => $item->id]),
                        "title" => __('common.clients'),
                        "icon" => "user"
                    ],
                    [
                        "url" => route('admin.raffle.sellers.index', ['id' => $item->id]),
                        "title" => __('common.menu.sellers'),
                        "icon" => "people-carry"
                    ],
                    [
                        "url" => route('admin.raffle.clients.returns', ['id' => $item->id]),
                        "title" => __('common.returns'),
                        "icon" => "exchange-alt"
                    ]  
                ]
            ])->render();
        }); 
    }

    public function generateUniqueLink(Request $request, $code) {
        if ($raffle = $this->resourceClass::published()->where('code', $code)->first()) {
            if ($raffle->usersCountWithTicket < $raffle->total_tickets && $request->has('seller_id')) {
                $link = $raffle->links()->create([
                    "id" => \Uuid::generate(4)->string,
                    "token" => \Str::random(40),
                    "created_by" => auth()->id(),
                    "seller_id" => $request->seller_id                
                ]);
                $url = route('public.raffles.unique.generate.link.client.token', ['id' => $link->id, 'token' => $link->token]);
                return response()->json(["message" => __('common.messages.link_generate_success'), "url" => $url]);
            }
            return response()->json(["error" => true, "message" => __('common.errors.error_limit_total_tickets')]);
        }
        return response()->json(["error" => true, "message" => __('common.errors.raffle_not_found', ['code' => $code])]);
    }

    public function updateWinner($id, $winning_client_id) {
        if ($raffle = $this->resourceClass::find($id)) {
            if ($client = \App\Models\Client::find($winning_client_id)) {
                $raffle->winning_client_id = $client->id;
                $raffle->save();
                return response()->json(["message" => "ok", "client" => $client]);
            }            
            return response()->json(["error" => true, "message" => __('common.errors.error_client_not_found')]);
        }
        return response()->json(["error" => true, "message" => __('common.errors.error_raffle_not_found')]);
    }

    public function addOrDeleteSeller($id, $seller_id, $action) {
        if ($raffle = $this->resourceClass::find($id)) {
            if ($seller = \App\Models\Seller::find($seller_id)) {
                if ($action == 'add') {                    
                    $raffle->sellers()->attach($seller->id, ['id' => \Uuid::generate(4)->string]);
                } else {
                    $raffle->sellers()->detach($seller->id);
                }                
                return response()->json(["message" => "ok"]);
            }         
            return response()->json(["error" => true, "message" => __('common.errors.error_seller_not_found')]);
        }
        return response()->json(["error" => true, "message" => __('common.errors.error_raffle_not_found')]);
    }

    public function sellers($code) {
        if ($raffle = $this->resourceClass::published()->where('code', $code)->first()) {
            $sellers = $raffle->sellers()->orderBy('names')->get();
            return response()->json(["sellers" => $sellers]);      
        }
        return response()->json(["error" => true, "message" => __('common.errors.raffle_not_found', ['code' => $code])]);
    }
}

app/Http/Controllers/RaffleController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

class RaffleController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct() {}

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Contracts\Support\Renderable
     */
    public function generateUniqueLink()
    {        
        return view('raffles.generate_unique_link');
    }

    public function getLinkUniqueClient($id, $token) {
        if ($link = \App\Models\Link::where(['id' => $id, 'token' => $token])->first()) {
            if ($raffle = $link->raffle()->published()->first()) {
                if (is_null($link->client_id)) {
                    return view('raffles.client.register', compact('link', 'raffle'));
                } else {
                    if ($client = $link->client) {
                        if (is_null($client->ticket)) {                            
                            $tickets = $this->getTickets($raffle);                            
                            return view('raffles.client.ticket', compact('raffle', 'link', 'client', 'tickets'));
                        } else {
                            return view('raffles.client.voucher', compact('raffle', 'client'));
                        }
                    }
                }
            }            
        }
        return abort(404);
    }

    private function getTickets($raffle) {
        $numbers = [];
        for ($x = 0; $x < $raffle->total_tickets; $x++)
            $numbers[] = ['id' => ($x + 1)];
        $tickets = collect($numbers);                            
        return $tickets->whereNotIn('id', $raffle->clients()->whereNotNull('ticket')->pluck('ticket'))->values();
    }

    public function show($id) {
        if ($raffle = \App\Models\Raffle::find($id)) {
            return view('raffles.show', compact('raffle'));
        }
        return abort(404);
    }

    public function generateLottery($id) {
        if ($raffle = \App\Models\Raffle::find($id)) {
            $winners = collect();
            $ids = $raffle->clients()->whereNotNull('ticket')->pluck('id');
            $winners = $this->recursiveWinners($winners, $ids);              
            return view('raffles.lottery', compact('raffle', 'winners'));
        }
        return abort(404);
    }

    private function recursiveWinners($winners, $ids) {
        if ($winners->count() === 3) {
            return $winners;
        } else {
            $id = $ids[rand(0, ($ids->count() - 1))];
            if (!$winners->firstWhere('id', $id)) {
                if ($client = \App\Models\Client::find($id)) {
                    $winners->push($client);
                }                
            }
            return $this->recursiveWinners($winners, $ids);
        }
    }
}

resources/views/admin/raffles/form.blade.php
<div class="row">
    @include('common.input', [
        "id" => "code",
        "required" => true,
        "clas" => "col-md-6",
        "label" => __('common.inputs.code'),
        "value" => (isset($item->code) ? $item->code : old('code')),
        "maxLength" => "5"
    ])
    @include('common.input', [
        "id" => "name",
        "required" => true,
        "clas" => "col-md-6",
        "label" => __('common.inputs.name'),
        "value" => (isset($item->name) ? $item->name : old('name'))
    ])
</div>
<div class="row">
    @include('common.input', [
        "id" => "published_at",
        "required" => true,
        "clas" => "col-md-6",
        "label" => __('common.inputs.published_at'),
        "value" => (isset($item->published_at) ? $item->published_at->format("Y-m-d") : old('published_at')),
        "type" => "date"
    ])
    @include('common.input', [
        "id" => "closed_at",
        "required" => true,
        "clas" => "col-md-6",
        "label" => __('common.inputs.closed_at'),
        "value" => (isset($item->closed_at) ? $item->closed_at->format("Y-m-d") : old('closed_at')),
        "type" => "date"
    ])
</div>
<div class="row">
    @include('common.textarea', [
        "id" => "description",
        "required" => true,
        "clas" => "col-md-12",
        "label" => __('common.inputs.description'),
        "value" => (isset($item->description) ? $item->description : old('description')),        
    ])
</div>
<div class="row">
    @include('common.input', [
        "id" => "total_tickets",
        "required" => true,
        "clas" => "col-md-6",
        "label" => __('common.inputs.total_tickets'),
        "value" => (isset($item->total_tickets) ? $item->total_tickets : old('total_tickets')),
        "type" => "number"
    ])
    @include('common.input', [
        "id" => "ticket_price",
        "required" => true,
        "clas" => "col-md-6",
        "label" => __('common.inputs.ticket_price'),
        "value" => (isset($item->ticket_price) ? $item->ticket_price : old('ticket_price')),
        "type" => "number"
    ])
</div>
@push('scripts')
    <script src="{{ asset('js/lib/ckeditor/ckeditor.js') }}"></script>
    <script>
        CKEDITOR.replace( 'description' );
    </script>
@endpush

resources/views/admin/raffles/form_images.blade.php
<x-content>
    <x-slot name="title">@lang('common.add') @lang('common.images')</x-slot>
    <div class="row py-4">
        <div class="col-md-12">
            @component('components.form', [
                "item" => null,
                "resource" => "raffles-images",                    
                "route" => route('admin.raffle.upload.image', ['id' => $item->id])
            ])            
            <div class="row">
                @include('common.input', [
                    "id" => "file",
                    "required" => true,
                    "clas" => "col-md-6",
                    "label" => __('common.inputs.image'),
                    "value" => '',
                    "type" => "file",
                    "accept" => "image/png, image/jpeg"
                ])
                @if ($item->images->count() > 0)                
                    <div class="col-md-6">
                        <label>Lista de imagenes</label>
                        <ul class="list-group">
                            @foreach ($item->images as $image)
                                <li class="list-group-item">
                                    <a href="{{ asset('images/raffles/' . $image->name) }}" target="_blank">{{ $image->name }}</a>
                                    
                                </li>                            
                            @endforeach                            
                        </ul>
                    </div>                
                @endif
            </div>                 
            @endcomponent 
        </div>
    </div>        
</x-content>

resources/views/admin/raffles/index.blade.php
@extends('layouts.app')

@section('content')
    @parent
    <x-content>
        <x-slot name="title">@lang('common.administration', ['model' => __('common.raffles')])</x-slot>
        <div class="row py-4">
            <div class="col-md-12">
                <a href="{{ route('admin.raffles.create') }}" class="btn btn-outline-primary float-right"><i class="fas fa-plus"></i> @lang('common.add')</a>
                <a href="{{ route('home') }}" class="btn btn-outline-dark"><i class="fas fa-long-arrow-alt-left"></i> @lang('common.cancel')</a>
            </div>
        </div>
        <div class="row">
            <div class="col-md-12">
                @include('common.table', [
                    "resource" => "raffles",
                    "headers" => [
                        "code" => __('common.inputs.code'),
                        "name" => __('common.inputs.name'),
                        "publication" => __('common.inputs.availability'),
                        "total_tickets" => __('common.inputs.total_tickets'),
                        "ticket_price" => __('common.inputs.ticket_price'),
                        "tickets_sold" => __('common.tickets_sold'),
                        "raised" => __('common.raised'),
                        "commission" => __('common.inputs.commission'),
                        "actions" => __('common.inputs.actions'),
                    ],
                    "url" => route('api.raffles.datatables')
                ])
            </div>
        </div>
    </x-content>
@endsection

resources/views/admin/raffles/item.blade.php
@extends('layouts.app')

@section('content')
    @parent
    <x-content>
        <x-slot name="title">@lang('common.' . (isset($item) ? 'edit' : 'add')) @lang('common.raffle')</x-slot>
        <div class="row py-4">
            <div class="col-md-12">
                @component('components.form', [
                    "item" => (isset($item) ? $item : null),
                    "resource" => "raffles",
                    "back" => route('admin.raffles.index'),
                    "updateResource" => "raffle"
                ])
                    @include('admin.raffles.form', ['item' => (isset($item) ? $item : null)])
                @endcomponent
            </div>
        </div>        
    </x-content>
    @isset($item)
        <br>
        @include('admin.raffles.form_images', ['item' => $item])
    @endisset
@endsection